Sub put_hflip(Byval x As Integer, Byval y As Integer, Byval img As Any Ptr)
   
    dim as integer w, h
    if imageinfo( img, w, h ) <> 0 then exit sub
   
    screenlock
       
        For x2 As Integer = 0 To w-1
            put (x + x2, y), img, (w-1 - x2, 0)-step(0, h-1), pset
        Next x2
       
    screenunlock
   
End Sub

Sub put_vflip(Byval x As Integer, Byval y As Integer, Byval img As Any Ptr)
   
    dim as integer w, h
    if imageinfo( img, w, h ) <> 0 then exit sub
   
    screenlock
       
        For y2 As Integer = 0 To h-1
            put (x, y + y2), img, (0, h-1 - y2)-step(w-1, 0), pset
        Next y2
       
    screenunlock
   
End Sub

/'
Const WID = 64, HEI = 48

screenres 320, 200, 32

Dim As Any Ptr img = imagecreate(wid, hei)

For y As Integer = 0 To HEI - 1
    var y2 = (y * 256) \ HEI
    For x As Integer = 0 To WID - 1
        var x2 = (x * 256) \ WID
        var r = x2
        var g = y2
        var b = x2 * y2
        Pset img, (x, y), RGB(r, g, b)
    Next x
Next y

screenlock
    Draw String (10, 0), "Original"
    Put (10, 10), img, Pset
   
    Draw String (10+WID+10, 0), "H-Flipped"
    put_hflip(10+WID+10, 10, img)
   
    Draw String (10, 10+HEI+10), "V-Flipped"
    put_vflip(10, 10+HEI+20, img)
screenunlock

Sleep
imagedestroy img
'/
