'###_CREDITS_###################################################################
'scale2x
'2010 by Landeel, 1000101, rolliebollocks
'source: http://www.freebasic.net/forum/viewtopic.php?p=138342

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"

'###_FUNCTIONES_################################################################
#Define        ITTERATIONS                100



Sub ImageEagle(Byval dst As FB.Image Ptr, Byval src As FB.Image Ptr)

'eagle
'first:        |Then
'. . . --\ CC  |S T U  --\ 1 2
'. C . --/ CC  |V C W  --/ 3 4
'. . .         |X Y Z
'              | IF V==S==T => 1=S
'              | IF T==U==W => 2=U
'              | IF V==X==Y => 3=X
'              | IF W==Z==Y => 4=Z


        Dim As Integer xx = src->Width,yy = src->Height
        Dim As Integer x2= dst->Width,y2= dst->Height
        Dim As Uinteger Ptr srcpixels = CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, src + 1 ) )
        Dim As Uinteger Ptr destpixels= CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, dst + 1 ) )
        'Dim As Uinteger A,B,C,D,P
        Dim As Uinteger S,T,U,V,C,W,X,Y,Z
        'result = ImageInfo ( [width] [, [height] [, [bypp] [, [pitch] [, [pixdata] [, [imgsize]]]]]] )
        'imageinfo buffer,x,y,,,srcpixels
        'Dim buffer2 As FB.Image Ptr=imagecreate(x*2,y*2,,32)
        'imageinfo buffer2,x2,y2,,,destpixels

    For j As Integer=0 To yy-1
    For i As Integer=0 To xx-1
        C=srcpixels[i+j*xx]
        'line buffer2,(i*2,j*2)-(i*2+1,j*2+1),P,BF
        destpixels[i*2+j*2*x2]=C
        destpixels[i*2+1+j*2*x2]=C
        destpixels[i*2+j*2*x2+x2]=C
        destpixels[i*2+1+j*2*x2+x2]=C
    Next i
    Next j

    For j As Integer=1 To yy-1
    For i As Integer=1 To xx-1
        C=srcpixels[i+j*xx]
        S=srcpixels[i-1+(j-1)*xx]
        T=srcpixels[i+(j-1)*xx]
        U=srcpixels[i+1+(j-1)*xx]
        V=srcpixels[i-1+j*xx]
        W=srcpixels[i+1+j*xx]
        X=srcpixels[i-1+(j+1)*xx]
        Y=srcpixels[i+(j+1)*xx]
        Z=srcpixels[i+1+(j+1)*xx]

'              | IF V==S==T => 1=S
'              | IF T==U==W => 2=U
'              | IF V==X==Y => 3=X
'              | IF W==Z==Y => 4=Z

        if V=S and S=T then destpixels[i*2+j*2*x2]=S
        if T=U and U=W then destpixels[i*2+1+j*2*x2]=U
        if V=X and X=Y then destpixels[i*2+j*2*x2+x2]=X
        if W=Z and Z=Y then destpixels[i*2+1+j*2*x2+x2]=Z

        'A=srcpixels[i+(j-1)*xx]
        'B=srcpixels[i+1+j*xx]
        'C=srcpixels[i-1+j*xx]
        'D=srcpixels[i+(j+1)*xx]
       
        'If C=A And C<>D And A<>B Then destpixels[i*2+j*2*x2]=A
        'If A=B And A<>C And B<>D Then destpixels[i*2+1+j*2*x2]=B
        'If B=D And B<>A And D<>C Then destpixels[i*2+1+j*2*x2+x2]=D
        'If D=C And D<>B And C<>A Then destpixels[i*2+j*2*x2+x2]=C
       

    Next i
    Next j
End Sub


Sub ImageScale2X_original(Byval dst As FB.Image Ptr, Byval src As FB.Image Ptr)

'scale2x
'  A    --\ 1 2
'C P B  --/ 3 4
'  D
 '1=P; 2=P; 3=P; 4=P;
 'IF C==A AND C!=D AND A!=B => 1=A
 'IF A==B AND A!=C AND B!=D => 2=B
 'IF B==D AND B!=A AND D!=C => 4=D
 'IF D==C AND D!=B AND C!=A => 3=C

        Dim As Integer x = src->Width,y = src->Height
        Dim As Uinteger A,B,C,D,P

    For j As Integer=0 To y-1
    For i As Integer=0 To x-1
        Line dst,(i*2,j*2)-(i*2+1,j*2+1),Point(i,j,src),BF
    Next i
    Next j

    For j As Integer=1 To y-2
    For i As Integer=1 To x-2
        P=Point(i,j,src)
        A=Point(i,j-1,src)
        B=Point(i+1,j,src)
        C=Point(i-1,j,src)
        D=Point(i,j+1,src)
       
        If C=A And C<>D And A<>B Then Pset dst,(i*2,j*2),A
        If A=B And A<>C And B<>D Then Pset dst,(i*2+1,j*2),B
        If B=D And B<>A And D<>C Then Pset dst,(i*2+1,j*2+1),D
        If D=C And D<>B And C<>A Then Pset dst,(i*2,j*2+1),C
       

    Next i
    Next j
End Sub




Sub ImageScale2X_landeel(Byval dst As FB.Image Ptr, Byval src As FB.Image Ptr)

'scale2x
'  A    --\ 1 2
'C P B  --/ 3 4
'  D
 '1=P; 2=P; 3=P; 4=P;
 'IF C==A AND C!=D AND A!=B => 1=A
 'IF A==B AND A!=C AND B!=D => 2=B
 'IF B==D AND B!=A AND D!=C => 4=D
 'IF D==C AND D!=B AND C!=A => 3=C

        Dim As Integer x = src->Width,y = src->Height
        Dim As Integer x2= dst->Width,y2= dst->Height
        Dim As Uinteger Ptr srcpixels = CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, src + 1 ) )
        Dim As Uinteger Ptr destpixels= CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, dst + 1 ) )
        Dim As Uinteger A,B,C,D,P
        'result = ImageInfo ( [width] [, [height] [, [bypp] [, [pitch] [, [pixdata] [, [imgsize]]]]]] )
        'imageinfo buffer,x,y,,,srcpixels
        'Dim buffer2 As FB.Image Ptr=imagecreate(x*2,y*2,,32)
        'imageinfo buffer2,x2,y2,,,destpixels

    For j As Integer=0 To y-1
    For i As Integer=0 To x-1
        P=srcpixels[i+j*x]
        'line buffer2,(i*2,j*2)-(i*2+1,j*2+1),P,BF
        destpixels[i*2+j*2*x2]=P
        destpixels[i*2+1+j*2*x2]=P
        destpixels[i*2+j*2*x2+x2]=P
        destpixels[i*2+1+j*2*x2+x2]=P
    Next i
    Next j

    For j As Integer=1 To y-1
    For i As Integer=1 To x-1
        P=srcpixels[i+j*x]
        A=srcpixels[i+(j-1)*x]
        B=srcpixels[i+1+j*x]
        C=srcpixels[i-1+j*x]
        D=srcpixels[i+(j+1)*x]
       
        If C=A And C<>D And A<>B Then destpixels[i*2+j*2*x2]=A
        If A=B And A<>C And B<>D Then destpixels[i*2+1+j*2*x2]=B
        If B=D And B<>A And D<>C Then destpixels[i*2+1+j*2*x2+x2]=D
        If D=C And D<>B And C<>A Then destpixels[i*2+j*2*x2+x2]=C
       

    Next i
    Next j
End Sub




Sub ImageScale2X_1000101(Byval dst As FB.Image Ptr, Byval src As FB.Image Ptr)
       
        'scale2x
        '  A    --\ 1 2
        'C P B  --/ 3 4
        '  D
        '1=P; 2=P; 3=P; 4=P;
        'IF C==A AND C!=D AND A!=B => 1=A
        'IF A==B AND A!=C AND B!=D => 2=B
        'IF D==C AND D!=B AND C!=A => 3=C
        'IF B==D AND B!=A AND D!=C => 4=D
       
        Dim As Integer                x = src->Width-1
        Dim As Integer                y = src->Height-1
        Dim As Integer                i = Any,j = Any, i2 = Any
        Dim As Uinteger                A = Any,B = Any,C = Any,D = Any,P = Any,p1 = Any,p2 = Any,p3 = Any,p4 = Any
        Dim As Uinteger                spitch = src->Pitch Shr 2
        Dim As Uinteger                dpitch = dst->Pitch Shr 1
        Dim As Uinteger Ptr        s1 = CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, src + 1 ) )
        Dim As Uinteger Ptr        d0 = CPtr( Uinteger Ptr, CPtr( FB.IMAGE Ptr, dst + 1 ) )
        Dim As Uinteger Ptr        s0 = s1 - spitch
        Dim As Uinteger Ptr        s2 = s1 + spitch
        Dim As Uinteger Ptr        d1 = d0 + ( dpitch Shr 1 )
       
       
        For j =0 To y
                i2 = 0
                For i =0 To x
                        P=s1[ i ]
                        p1=P:p2=P:p3=P:p4=P
                       
                        If( j = 0 )Then A=P Else A=s0[ i   ]
                        If( i = 0 )Then C=P Else C=s1[ i-1 ]
                        If( i = x )Then B=P Else B=s1[ i+1 ]
                        If( j = y )Then D=P Else D=s2[ i   ]
                       
                        If( A <> D )And( C <> B )Then
                                p1 = IIf( C = A, C, P )
                                p2 = IIf( A = B, B, P )
                                p3 = IIf( C = D, C, P )
                                p4 = IIf( D = B, B, P )
                        Else
                                p1 = P
                                p2 = P
                                p3 = P
                                p4 = P
                        End If
                       
                        d0[ i2   ] = p1
                        d0[ i2+1 ] = p2
                        d1[ i2   ] = p3
                        d1[ i2+1 ] = p4
                       
                        i2 += 2
                       
                Next i
                s0 += sPitch
                s1 += sPitch
                s2 += sPitch
                d0 += dPitch
                d1 += dPitch
        Next j
End Sub



Dim As Double                mytime = Timer
Dim As Integer                Count
Dim As fb.image Ptr        src
Dim As fb.image Ptr        dst




'by rolliebollocks
Function Dilate_Lines ( img As fb.image Ptr, xScale As Single, yScale As Single ) As fb.image Ptr
   
    Dim As Integer w = img->width
    Dim As Integer h = img->height
    Dim As Integer pitch = img->pitch
    Dim As Ubyte Ptr pixdata = Cast( Ubyte Ptr, img ) + Sizeof( FB.IMAGE )
    Dim As fb.image Ptr res = imagecreate ( w*xScale, h*yScale )
    Dim As Single offsetx = xScale/2, offsety = yScale/2
   
    For iy As Integer = 0 To h-1
        For ix As Integer = 0 To w - 1
            Line res, ( xScale*(ix - offsetx), yScale*(iy - offsety) )-( xScale*(ix + offsetx), yScale*(iy + offsety)), Cast( Uinteger Ptr, pixdata + ( iy * pitch ) )[ ix ],bf
        Next
    Next
   
    Return res
End Function


'###_EXAMPLE_###################################################################
/'
screenres 640,480,32



'src = imagecreate(170,34,0,32)                '' <--- ImageScale2x_landeel can't handle arbitrary images
src = imagecreate(256,64,0,32)                '' <--- must use pow2 for this example
dst = imagecreate(src->Width*2,src->Height*2,0,32)




Line src, (10,10)-(160,24),rgb(0,0,255)
Circle src, (16,16),16,rgb(255,0,0),,,,F
Draw String src, (20,5),"Scaling is awesome!"
Put(0,0),src,Pset




'ImageScale2X_original(dst,src)
ImageEagle(dst,src)
Put(100,100),dst,Pset
Draw String ( 10, 100 ), "eagle:"

ImageScale2X_landeel(dst,src)
Put(100,200),dst,Pset
Draw String ( 10, 200 ), "landeel:"

ImageScale2X_1000101(dst,src)
Put(100,300),dst,Pset
Draw String ( 10, 300 ), "1000101:"



mytime=Timer()
For Count = 1 To ITTERATIONS
        ImageEagle(dst,src)
Next
mytime=(Timer()-mytime)/ITTERATIONS
Draw String ( 20, 110 ),Left( Str( mytime ), 8 ) + "s"


mytime=Timer()
For Count = 1 To ITTERATIONS
        ImageScale2X_landeel(dst,src)
Next
mytime=(Timer()-mytime)/ITTERATIONS
Draw String ( 20, 210 ),Left( Str( mytime ), 8 ) + "s"




mytime=Timer()
For Count = 1 To ITTERATIONS
        ImageScale2X_1000101(dst,src)
Next
mytime=(Timer()-mytime)/ITTERATIONS
Draw String ( 20, 310 ),Left( Str( mytime ), 8 ) + "s"




Sleep

ImageDestroy( src )
ImageDestroy( dst )

End
'/
