'###_CREDITS_###################################################################
'sndloader 1.1
'2008-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fmod.bi"

'###_SHARED_VALUES_#############################################################
dim shared as ubyte volume_music=96,volume_sound=196

'###_FUNCTIONES_################################################################
'-------------------------------------------------------------------------------
declare sub loadsnd(byref sound_name as integer ptr,sound_path as string)
sub         loadsnd(byref sound_name as integer ptr,sound_path as string)
    
    sound_name=FSOUND_SAMPLE_Load(FSOUND_FREE,sound_path,0,0,0)
    
end sub

'-------------------------------------------------------------------------------
declare sub playsnd(sound_name as integer ptr)
sub         playsnd(sound_name as integer ptr)
    
    FSOUND_PlaySound (FSOUND_FREE,sound_name)
    FSOUND_SetSFXMasterVolume(volume_sound)
    
end sub

'-------------------------------------------------------------------------------
declare sub loadstr(byref stream_name as integer ptr,stream_path as string,stream_loop as byte=0)
sub         loadstr(byref stream_name as integer ptr,stream_path as string,stream_loop as byte=0)
    
    if stream_loop = 1 then
        stream_name=FSOUND_Stream_Open(stream_path,FSOUND_LOOP_NORMAL,0,0)
    else
        stream_name=FSOUND_Stream_Open(stream_path,0,0,0)
    endif
    
end sub

'-------------------------------------------------------------------------------
declare sub playstr(stream_name as integer ptr)
sub         playstr(stream_name as integer ptr)
    
    FSOUND_Stream_Play(1,stream_name)
    FSOUND_SetVolumeAbsolute(1,volume_music)
    
end sub

'-------------------------------------------------------------------------------
declare sub pausstr(pause_value as byte=1)
sub         pausstr(pause_value as byte=1)
    
    FSOUND_SetPaused(1,pause_value)
    
end sub

'-------------------------------------------------------------------------------
declare sub stopstr(stream_name as integer ptr)
sub         stopstr(stream_name as integer ptr)
    
    FSOUND_Stream_Stop stream_name
    FSOUND_Stream_Close stream_name

end sub

'-------------------------------------------------------------------------------
declare sub initsnd()
sub         initsnd()
    
    FSOUND_Init(44100,8,0)
    
end sub

'-------------------------------------------------------------------------------
declare sub endsnd()
sub         endsnd()
    
    FSOUND_Close
    
end sub

'###_EXAMPLE_###################################################################
/'
initsnd()
dim shared as integer ptr song
loadstr(song,"river.ogg")
playstr(song)
dim shared as integer ptr water
loadsnd(water,"sound1.wav")
playsnd(water)
sleep 2000
pausstr()
sleep 2000
pausstr(0)
sleep 2000
stopstr(song)
sleep 1000
endsnd()
'/
